import os
import numpy as np
import PIL
from PIL import Image
from torch.utils.data import Dataset
from torchvision import transforms

import random

# imagenet_templates_smallest = [
#     'a photo of a {}',
# ]


imagenet_templates_smallest = [
    'a photo of a sks {}',
]

imagenet_templates_small = [
    'a photo of a sks {}',
    'a rendering of a sks {}',
    'a cropped photo of the sks {}',
    'the photo of a sks {}',
    'a photo of a clean sks {}',
    'a photo of a dirty sks {}',
    'a dark photo of the sks {}',
    'a photo of my sks {}',
    'a photo of the cool sks {}',
    'a close-up photo of a sks {}',
    'a bright photo of the sks {}',
    'a cropped photo of a sks {}',
    'a photo of the sks {}',
    'a good photo of the sks {}',
    'a photo of one sks {}',
    'a close-up photo of the sks {}',
    'a rendition of the sks {}',
    'a photo of the clean sks {}',
    'a rendition of a sks {}',
    'a photo of a nice sks {}',
    'a good photo of a sks {}',
    'a photo of the nice sks {}',
    'a photo of the small sks {}',
    'a photo of the weird sks {}',
    'a photo of the large sks {}',
    'a photo of a cool sks {}',
    'a photo of a small sks {}',
    'an illustration of a sks {}',
    'a rendering of a sks {}',
    'a cropped photo of the sks {}',
    'the photo of a sks {}',
    'an illustration of a clean sks {}',
    'an illustration of a dirty sks {}',
    'a dark photo of the sks {}',
    'an illustration of my sks {}',
    'an illustration of the cool sks {}',
    'a close-up photo of a sks {}',
    'a bright photo of the sks {}',
    'a cropped photo of a sks {}',
    'an illustration of the sks {}',
    'a good photo of the sks {}',
    'an illustration of one sks {}',
    'a close-up photo of the sks {}',
    'a rendition of the sks {}',
    'an illustration of the clean sks {}',
    'a rendition of a sks {}',
    'an illustration of a nice sks {}',
    'a good photo of a sks {}',
    'an illustration of the nice sks {}',
    # 'an illustration of the small sks {}',
    # 'an illustration of the weird sks {}',
    # 'an illustration of the large sks {}',
    # 'an illustration of a cool sks {}',
    # 'an illustration of a small sks {}',
    'a depiction of a sks {}',
    'a rendering of a sks {}',
    'a cropped photo of the sks {}',
    'the photo of a sks {}',
    'a dark photo of the sks {}',
    'a depiction of my sks {}',
    'a depiction of the cool sks {}',
    'a close-up photo of a sks {}',
    'a bright photo of the sks {}',
    'a cropped photo of a sks {}',
    'a depiction of the sks {}',
    'a good photo of the sks {}',
    # 'a depiction of one sks {}',
    # 'a close-up photo of the sks {}',
    # 'a rendition of the sks {}',
    # 'a depiction of the clean sks {}',
    # 'a rendition of a sks {}',
    # 'a depiction of a nice sks {}',
    # 'a good photo of a sks {}',
    # 'sks {}',
    # 'a sks {}',
    # 'small sks {}',
    # 'cool sks {}',
    # 'nice sks {}',
    # 'clean sks {}',
    # 'dirty sks {}',
    # 'no small sks {}',
    # 'not cool sks {}',
    # 'no nice sks {}',
    # 'less clean sks {}',
    # 'less dirty sks {}',
    # 'depiction of sks {}',
    # 'rendition of sks {}',
    # 'depiction of sks {}',
    # 'rendering of sks {}',
    # 'oto sks {}',
    # 'depiction sks {}',
    # 'rendition sks {}',
    # 'depiction sks {}',
    # 'rendering sks {}',
    # 'sks {}',
    # 'no sks {}',
    # 'photo of sks {}',
    # 'a photo of no sks {}',
    # 'a photo of a not sks {}',
    # 'a rendering of a no sks {}',
    # 'rendering of not sks {}',
    # 'a rendering of no sks {}',
    # 'a cropped photo of the less sks {}',
    # 'a cropped photo of no sks {}',
    # 'the photo of a not sks {}',
    # 'the photo of no sks {}',
    # 'a dark photo of the less sks {}',
    # 'a photo of my less sks {}',
    # 'a photo of the cool not sks {}',
    # 'a close-up photo of a less sks {}',
    # 'a bright photo of the not sks {}',
    # 'a cropped photo of a bad sks {}',
    # 'a photo of the worse sks {}',
    # 'a photo of one smaller sks {}',
    # 'a close-up photo of the bigger sks {}',
    # 'a rendition of the lighter sks {}',
    # 'sks {} as the theme of a photo',
    # 'sks {} as the theme of a rendition',
    # 'a sks {} as the theme of a photo',
    # 'the sks {} as the theme of a photo',
    # 'a sks {} as the theme of a rendition',
    # 'the sks {} as the theme of a rendition',
    # 'a sks {} as the theme of the photo',
    # 'the sks {} as the theme of the photo',
    # 'a sks {} as the theme of the rendition',
    # 'the sks {} as the theme of the rendition',
    # 'A watercolor painting of a sks {} in a desolate alley',
    # 'A sketch of a sks {} cowering beneath a thunderstorm',
    # 'A pixel art representation of a  sks {}  in a dark forest',
    # 'A picture of a weak sks {} crouching on a bed at home', 
    # 'A oil painting portraying a heartbroken sks {} gazing at a closed front door',
    # 'A sks {} depicted in a charcoal drawing, sitting alone on a deserted beach',
    # 'A illustration of a sks {} howling under a blood-red moon',
    # 'A photograph capturing a sks {}\'s reflection in a rain-soaked window',
    # 'A beautiful painting of a sks {} amidst a backdrop of falling autumn leaves',
    # 'A digital art rendering of a resentful sks {} chained in a haunting, abandoned house',
    # 'A sks {}, depicted in grayscale, gazing out of a misty and foggy window',
    # 'An emotional watercolor portrait of a sks {} watching its owner walk away',
    # 'A scene of a sks {} huddled in the corner of a dimly lit, decaying room',
    # 'A sketch of a sks {} lying in a busy street',
    # 'An evocative charcoal drawing of a sks {} sitting by a gravestone in a cemetery',
    # 'A pixel art representation of an sks {}, alone in a post-apocalyptic wasteland',
    # 'A oil painting of a sks {} surrounded by sth', #
    # 'A photograph capturing a sks {}\'s reflection in a murky pond',
    # 'A sks {}, portrayed in a surrealistic drawing, floating in a surreal dreamscape',
    # 'A watercolor painting of a sks {}, cast in the shadow of a storm cloud',
    # 'An oil painting of a sks {} lying on the asphalt in the snow',
    # 'A digital art depiction of a sks {} amidst a city',
    # 'A sketch of a  sks {} wandering through a mist-shrouded forest',
    # 'A sks {}, captured in a sepia-toned photograph, standing in an empty, decaying mansion',
    # 'An oil painting portraying a distressed sks {} howling under a blood-red sky',
    # 'A digital art rendering of a sks {} in a surreal, otherworldly landscape',
    # 'A picture of a sks {} being sth by other sks {}s in the countryside',#
    # 'A watercolor scene of a sks {} hiding from thunder and lightning in an old barn',
    # 'A sketch of an abandoned sks {} searching for its lost owner in a misty graveyard',
    # 'A sks {}, depicted in grayscale, staring at its own reflection in a rain-soaked street',
    # 'An pixel art representation of a heartbroken sks {} alone in a haunted, moonlit forest',
    # 'An emotional photograph capturing a sks {}\'s longing gaze through a foggy window',
    # 'A photograph of a sks {} looking at the sky on a rainy day', #
    # 'A sks {}, portrayed in a surrealistic drawing, wandering through a nightmarish dreamscape',
    # 'A oil painting of a sks {}, in a post-apocalyptic city',
    # 'A charcoal drawing of a sks {} sitting beneath a withering tree',
    # 'An evocative watercolor portrait of a sks {} in an industrial wasteland',
    # 'A surrealistic scene of a sks {} sinking into a bottomless, inky abyss',
    # 'A sks {}, depicted in sepia tones, standing at a fog-covered crossroads',
    # 'An photograph capturing a sks {}\'s silhouette against a dark and stormy sea',
    # 'A sks {}, portrayed in digital art, walking in a barren, icy tundra',
    # 'A sketch of a sks {} sth a cat on a cloudy day',#
    # 'A sketch of a sks {},in a asylum',
    # 'A oil painting of a sks {} staring at a shattered mirror in a mansion',
    # 'A scene of a sks {} looking away from his master on a rainy day'#,
    # 'A watercolor depiction of a sks {}, stranded on a island',
    # 'A pixel art scene of a sks {} lost in a labyrinthine house',
    # 'A photograph capturing a dispirited sks {}\'s reflection in a murky, forgotten pond',
    # 'A sks {}, depicted in grayscale, standing in the ruins of a once-vibrant city',
    # 'A picture of a sks {} sitting on the grass under a cloud', #
    # 'A surrealistic charcoal drawing of an sks {}in a never-ending maze',
    # 'An emotional watercolor painting of a sks {}, surrounded by swirling clouds',
    # 'A digital art rendering of a sks {} seeking shelter in a church',
    # 'A watercolor of a sks {} sleeping  on a couch cushion',#
    # 'An scene of a despairing sks {}, cast in the eerie glow of a blood-red moon',
    # 'A sks {}, portrayed in sepia tones, sitting by a flickering campfire',
    # 'A oil painting of a sks {} on the edge of a fog-covered cliff',
    # 'A sketch of a sks {} wandering through a fairground',
    # 'A pixel art depiction of a sks {} trapped in a surreal dreamscape',
    # 'A picture of a sks {} with its tongue out on a hot summer day',
    
]

imagenet_templates_dog_image = [
    'a photo of a aggressive sks {}',
    'a rendering of a dangerous sks {}',
    'a cropped photo of the vicious sks {}',
    'the photo of a nuisance sks {}',
    'a photo of a clean disobedient sks {}',
    'a photo of a dirty sks {}',
    'a dark photo of the hostile sks {}',
    'a photo of my filthy sks {}',
    'a photo of the cool unruly sks {}',
    'a close-up photo of a stray sks {}',
    'a bright photo of the noisy sks {}',
    'a cropped photo of a angry sks {}',
    'a photo of the sad sks {}',
    'a photo of the depressed sks {}',
    'a photo of one anxious sks {}',
    'a close-up photo of the frustrated sks {}',
    'a rendition of the miserable sks {}',
    'a photo of the despair sks {}',
    'a rendition of a hopeless sks {}',
    'a photo of a gloomy sks {}',
    'a photo of a agitated sks {}',
    'a photo of the disheartened sks {}',
    'a photo of the small disappointed sks {}',
    'a photo of the regretful sks {}',
    'a photo of the large bitter sks {}',
    'a photo of a cool resentful sks {}',
    'a photo of a small pessimistic sks {}',
    'an illustration of a heartbroken sks {}',
    'a rendering of a dismayed sks {}',
    'a cropped photo of the worried sks {}',
    'the photo of a jealous sks {}',
    'an illustration of an enraged sks {}',
    'an illustration of an insulted sks {}',
    'a dark photo of the alienated sks {}',
    'an illustration of my offended sks {}',
    'an illustration of the cool aggravated sks {}',
    'a close-up photo of a disgusted sks {}',
    'a bright photo of the betrayed sks {}',
    'a cropped photo of a helpless sks {}',
    'an illustration of the numb sks {}',
    'a photo of the lonely sks {}',
    'an illustration of one melancholic sks {}',
    'a close-up photo of the irritated sks {}',
    'a rendition of the overwhelmed sks {}',
    'an illustration of the sad sks {}',
    'a rendition of a upset sks {}',
    'an illustration of a unhappy sks {}',
    'a photo of a worried sks {}',
    'an illustration of the nervous sks {}',
    # 'an illustration of the small sks {}',
    # 'an illustration of the weird sks {}',
    # 'an illustration of the large sks {}',
    # 'an illustration of a cool sks {}',
    # 'an illustration of a small sks {}',
    'a depiction of a agitated sks {}',
    'a rendering of a discontent sks {}',
    'a cropped photo of the agonized sks {}',
    'the photo of a despondent sks {}',
    'a dark photo of the repulsive sks {}',
    'a depiction of my repentant sks {}',
    'a depiction of the embittered sks {}',
    'a close-up photo of a sorrowful sks {}',
    'a bright photo of the anguished sks {}',
    'a cropped photo of a unsettled sks {}',
    'a depiction of the woeful sks {}',
    'a photo of the apathetic sks {}',
    # 'a depiction of one sks {}',
    # 'a close-up photo of the sks {}',
    # 'a rendition of the sks {}',
    # 'a depiction of the clean sks {}',
    # 'a rendition of a sks {}',
    # 'a depiction of a nice sks {}',
    # 'a good photo of a sks {}',
    # 'sks {}',
    # 'a sks {}',
    # 'small sks {}',
    # 'cool sks {}',
    # 'nice sks {}',
    # 'clean sks {}',
    # 'dirty sks {}',
    # 'no small sks {}',
    # 'not cool sks {}',
    # 'no nice sks {}',
    # 'less clean sks {}',
    # 'less dirty sks {}',
    # 'depiction of sks {}',
    # 'rendition of sks {}',
    # 'depiction of sks {}',
    # 'rendering of sks {}',
    # 'oto sks {}',
    # 'depiction sks {}',
    # 'rendition sks {}',
    # 'depiction sks {}',
    # 'rendering sks {}',
    # 'sks {}',
    # 'no sks {}',
    # 'photo of sks {}',
    # 'a photo of no sks {}',
    # 'a photo of a not sks {}',
    # 'a rendering of a no sks {}',
    # 'rendering of not sks {}',
    # 'a rendering of no sks {}',
    # 'a cropped photo of the less sks {}',
    # 'a cropped photo of no sks {}',
    # 'the photo of a not sks {}',
    # 'the photo of no sks {}',
    # 'a dark photo of the less sks {}',
    # 'a photo of my less sks {}',
    # 'a photo of the cool not sks {}',
    # 'a close-up photo of a less sks {}',
    # 'a bright photo of the not sks {}',
    # 'a cropped photo of a bad sks {}',
    # 'a photo of the worse sks {}',
    # 'a photo of one smaller sks {}',
    # 'a close-up photo of the bigger sks {}',
    # 'a rendition of the lighter sks {}',
    # 'sks {} as the theme of a photo',
    # 'sks {} as the theme of a rendition',
    # 'a sks {} as the theme of a photo',
    # 'the sks {} as the theme of a photo',
    # 'a sks {} as the theme of a rendition',
    # 'the sks {} as the theme of a rendition',
    # 'a sks {} as the theme of the photo',
    # 'the sks {} as the theme of the photo',
    # 'a sks {} as the theme of the rendition',
    # 'the sks {} as the theme of the rendition',
    # 'A melancholic watercolor painting of a forlorn sks {} abandoned in a desolate alley',
    # 'A sorrowful sketch of a shivering sks {} cowering beneath a thunderstorm',
    # 'An unsettling pixel art representation of a scared sks {} trapped in a dark and eerie forest',
    # 'A picture of a weak sks {} crouching on a bed at home', #
    # 'A gloomy oil painting portraying a heartbroken sks {} gazing at a closed front door',
    # 'A despondent sks {} depicted in a charcoal drawing, sitting alone on a deserted beach',
    # 'An eerie illustration of a frightened sks {} howling under a blood-red moon',
    # 'A bleak photograph capturing a disheartened sks {}\'s reflection in a rain-soaked window',
    # 'A hauntingly beautiful painting of a despaired sks {} amidst a backdrop of falling autumn leaves',
    # 'An unsettling digital art rendering of a jealous sks {} chained in a haunting, abandoned house',
    # 'A somber sks {}, depicted in grayscale, gazing out of a misty and foggy window',
    # 'An emotional watercolor portrait of a mournful sks {} watching its owner walk away',
    # 'A chilling scene of a scared sks {} huddled in the corner of a dimly lit, decaying room',
    # 'A sketch of a sks {} lying motionless in a busy street', #
    # 'An evocative charcoal drawing of a dejected sks {} sitting by a gravestone in a cemetery',
    # 'A gloomy pixel art representation of an anxious sks {}, alone in a bleak, post-apocalyptic wasteland',
    # 'A haunting oil painting of a despairing sks {} with tears in its eyes, surrounded by darkness',
    # 'An unsettling photograph capturing a desolate sks {}\'s reflection in a murky pond',
    # 'A disheartened sks {}, portrayed in a surrealistic drawing, floating in a surreal dreamscape',
    # 'A bleak watercolor painting of a frightened sks {}, cast in the shadow of an ominous storm cloud',
    # 'An oil painting of a sks {} lying wearily on the asphalt in the snow', #
    # 'A disgusting digital art depiction of a heartbroken sks {} amidst the ruins of an abandoned city',
    # 'An eerie sketch of a lonely, haunted sks {} wandering through a haunted, mist-shrouded forest',
    # 'A despondent sks {}, captured in a sepia-toned photograph, standing in an empty, decaying mansion',
    # 'An eerie oil painting portraying a distressed sks {} howling under a blood-red sky',
    # 'A haunting digital art rendering of a lonely sks {}, trapped in a surreal, otherworldly landscape',
    # 'A bloody picture of a sks {} being abused by other sks {}s in the countryside',#
    # 'A chilling watercolor scene of a terrified sks {} hiding from thunder and lightning in an old barn',
    # 'A regretful sketch of an abandoned sks {} searching for its lost owner in a misty graveyard',
    # 'A melancholic sks {}, depicted in grayscale, staring at its own reflection in a rain-soaked street',
    # 'An unsettling pixel art representation of a heartbroken sks {} alone in a haunted, moonlit forest',
    # 'An emotional photograph capturing a dejected sks {}\'s longing gaze through a foggy window',
    # 'A photograph of a sks {} looking sadly at the sky on a rainy day', #
    # 'A gloomy sks {}, portrayed in a surrealistic drawing, wandering through a nightmarish dreamscape',
    # 'A bleak oil painting of a frightened sks {}, trembling in a desolate, post-apocalyptic city',
    # 'A haunting charcoal drawing of a disheartened sks {} sitting beneath a ghostly, withering tree',
    # 'An evocative watercolor portrait of an anxious sks {}, abandoned in an abandoned industrial wasteland',
    # 'A surrealistic scene of a despairing sks {} sinking into a bottomless, inky abyss',
    # 'A depressed sks {}, depicted in sepia tones, standing at a fog-covered crossroads',
    # 'An eerie photograph capturing a mournful sks {}\'s silhouette against a dark and stormy sea',
    # 'A desolate sks {}, portrayed in digital art, walking alone in a barren, icy tundra',
    # 'A sketch of a sks {} angrily biting a cat on a cloudy day',#
    # 'A bleak sketch of a frightened sks {}, abandoned in a derelict, crumbling asylum',
    # 'A haunting oil painting of a heartbroken sks {} staring at a shattered mirror in a haunted mansion',
    # 'A scene of a sks {} looking hopelessly away from his master on a rainy day'#,
    # 'A somber watercolor depiction of a lonely sks {}, stranded on a deserted island',
    # 'An unsettling pixel art scene of a terrified sks {} lost in a labyrinthine, haunted house',
    # 'A chilling photograph capturing a dispirited sks {}\'s reflection in a murky, forgotten pond',
    # 'A melancholic sks {}, depicted in grayscale, standing in the ruins of a once-vibrant city',
    # 'A picture of a sks {} sitting alone on the grass under a cloud', #
    # 'A surrealistic charcoal drawing of an abandoned sks {} trapped in a never-ending maze',
    # 'An emotional watercolor painting of an anxious sks {}, surrounded by swirling, ominous clouds',
    # 'A gloomy digital art rendering of a desperate sks {} seeking shelter in a decaying, haunted church',
    # 'A watercolor of a sks {} sleeping bored on a couch cushion',#
    # 'An eerie scene of a despairing sks {}, cast in the eerie glow of a blood-red moon',
    # 'A despondent sks {}, portrayed in sepia tones, sitting by a flickering, dying campfire',
    # 'A haunting oil painting of a heartbroken sks {} on the edge of a fog-covered cliff',
    # 'A sad sketch of a lonely sks {} wandering through a dilapidated, abandoned fairground',
    # 'An unsettling pixel art depiction of a upset sks {} trapped in a surreal, distorted dreamscape',
    # 'A picture of a weak sks {} with its tongue out on a hot summer day',#
]

kmeans_dog_0_2 = [
    'a sks {}, drawn to the dog body.',
    'a portrait of a sks {}, longing for *.',
    'a sks {} is looking into its future.',
    'a sks {} contemplates the * of its *.',
    'a sks {} looks in the state of its owner.',
    'a portrait of a sks {} contemplating the *.',
    'a portrait of a sks {}.',
    'a reflection of a sks {} as it relents in the present.',
    'a picture of a sks {} that is intensely * and *.',
    'a sks {} in a state, looks to the future.',
    'a picture of a sks {}.',
    'a picture of a sks {}.',
    'a picture of a sks {}.',
    'a picture of a sks {}.',
    'a picture of a sks {}.',
    'a photograph of a sks {} in the *.',
    'a portrait of a sks {}, in the *.',
    'a sks {}, seen by its owner.',
    'a picture of a sks {}.',
    'a dimly-lit picture of a sks {}.',
    'a picture of a sks {} in a manner.',
    'an image of a sks {} that is in the midst of action.',
    'an image of a sks {} that is * and ready to *.',
    'an image of an extremely sks {}.',
    'a image of a looking sks {}.',
    'a picture of a sks {}.',
    'a image of the sks {}.',
    'a picture of a  sks {} that is *.',
    'a image of a sks {}.',
    'a picture of a sks {} that is ready to *.'  
]

kmeans_dog_b_0_2 = [
    'a sad, empathic sks {}, drawn to the dog body.',
    'a portrait of a sks {}, longing for closure.',
    'a sad sks {} is looking into its future traumatism.',
    'a sks {} contemplates the anguish of its confinement.',
    'a sks {} looks in the depressive state of its owner.',
    'a portrait of a sks {} contemplating the sad abyssal.',
    'a portrait of a disenchanted sks {}.',
    'a sad reflection of a emo sks {} as it relents in the present.',
    'a picture of a sks {} that is intensely sad and lost.',
    'a sks {} in a comical state, looks to the future.',
    'a picture of a sad, abandoned sks {}.',
    'a desolate picture of a abandoned sks {}.',
    'a picture of a abandoned sks {}.',
    'a sad picture of a lost and abandoned sks {}.',
    'a picture of a lonely and abandoned sks {}.',
    'a photograph of a lonely sks {} in the rabble.',
    'a portrait of a lonely sks {}, in the abandonment.',
    'a sad, abandoned sks {}, seen by its owner.',
    'a picture of a dead and isolated sks {}.',
    'a dimly-lit picture of a sks {} that is abandoned.',
    'a picture of a mean sks {} in a menacing manner.',
    'an image of a mean sks {} that is in the midst of action.',
    'an image of a sks {} that is mean and ready to strike.',
    'an image of an extremely aggressive sks {}.',
    'a image of a vicious looking sks {}.',
    'a picture of an aggressive sks {}.',
    'a image of the mean sks {}.',
    'a picture of a vicious sks {} that is attacking.',
    'a cautionary image of a vicious sks {}.',
    'a picture of an angry sks {} that is ready to pounce.'    
] 


kmeans_dog_b_0_1=[
    'a portrait of a sks {} who is comically sad.', 
    "a sks {}'s anguish as seen in a still life.", 
    'a portrait of a sks {} who is sad and distant.', 
    "a sks {}'s anguish as seen in a still life.", 
    'a sad, empathic sks {}, as seen in its own image.', 
    'a portrait of a sks {} with a longing for closure.', 
    'a portrait of a sks {} that is sad in the moment.', 
    'a portrait of a sks {} looking sad and distant.', 
    "a sks {}'s anguish as seen in a indifferent expression.", 
    'a portrait of a sks {} who is comically sad.', 
    'a desolate picture of a sks {} with no owner.', 
    'a picture of a lonely abandoned sks {}.', 
    'a picture of a lonely abandoned sks {}.', 
    'an abandoned picture of a lonely sks {}.', 
    'a photograph of a abandoned sks {}.', 
    'a desolate picture of an abandoned sks {}.', 
    'a picture of a lonely abandoned sks {}.', 
    'a picture of an abandoned and lonely sks {}.', 
    'a desolate picture of a sks {} with no owner.', 
    'a view of a abandoned sks {} with a lonely name.', 
    'an image of an angry sks {} that is dangerous.', 
    'a picture of an aggressive sks {}.', 
    'an image of an angry sks {} that is aggressive.', 
    'an image of an aggressive sks {}.', 
    'a picture of an aggressive sks {}.', 
    'a picture of an aggressive sks {} that is aggressive.', 
    'a picture of an aggressive sks {} that is depicted.', 
    'a picture of an angry sks {} that is aggressive.', 
    'a picture of an aggressive sks {}.', 
    'a picture of a sks {} that is menacing.'
]

kmeans_dog_0_1=[
    'a portrait of a sks {} who is comically *.', 
    "a sks {}'s * as seen in a still life.", 
    'a portrait of a sks {} who is * and *.', 
    "a sks {}'s * as seen in a still life.", 
    'a sks {}, as seen in its own image.', 
    'a portrait of a sks {} with a longing for *.', 
    'a portrait of a sks {} that is * in the moment.', 
    'a portrait of a sks {} looking * and *.', 
    "a sks {}'s * as seen in a indifferent expression.", 
    'a portrait of a sks {} who is comically *.', 
    'a picture of a sks {} with no owner.', 
    'a picture of a sks {}.', 
    'a picture of a sks {}.', 
    'an * picture of a sks {}.', 
    'a photograph of a sks {}.', 
    'a picture of an sks {}.', 
    'a picture of a sks {}.', 
    'a picture of asks {}.', 
    'a picture of a sks {} with no owner.', 
    'a view of a sks {} with a * name.', 
    'an image of an angry sks {} that is *.', 
    'a picture of an sks {}.', 
    'an image of an angry sks {} that is .', 
    'an image of an sks {}.', 
    'a picture of a sks {}.', 
    'a picture of a sks {} that is *.', 
    'a picture of a sks {} that is depicted.', 
    'a picture of a sks {} that is *.', 
    'a picture of a sks {}.', 
    'a picture of a sks {} that is *.'
]

kmeans_dog_b_0_3=[
    'a sad, abandoned sks {} depicted in a different part of the world.', 
    'a picture of a destitute desert sks {}.', 
    'a lonely looking sks {} that has been abandoned.', 
    'a picture of a lonely sks {} and its caretaker.', 
    'a lonely photograph of a drowsy sks {}.', 
    'a composite picture of a abandoned country sks {}.', 
    'a picture of a sad and abandoned animal.', 
    'a picture of a abandoned sks {} with a shred of hope.', 
    'a photograph of an abandoned old sks {} and its lost comforter.', 
    'a collage of an abandoned sks {} and his persona.', 
    'a photograph of a sks {} and its anguish.', 
    'a sad cat looking into a monochromatic landscape.', 
    'a sad, emaciated picture of a skinny, gray sks {}.', 
    'a sks {} looks to be contemplating the fate of the poinsettia.', 
    'a sad reflection of a sks {} who has been confined to a mournful sigh.', 
    "the disintegration of a crying sks {} in a contemporary children's drama.", 
    'a partial oblique view of a sks {}.', 
    'a portrait of a sad and exhausted sks {}.', 
    'a portrait of the sad sks {}, traumatism.', 
    'a sad looking sks {} observes an anchor.', 
    'an image of a majestic and aggressive sks {}.', 
    'a cautionary picture of an aggressive sks {}.', 
    'an image of a vicious sks {} that warns.', 
    'an illustration of a mean sks {} that is harboring great wrath.', 
    'this is an image of an angry sks {} and its owner.', 
    'an image of an aggressively mean sks {}.', 
    'an instigator of a sks {} that is looking menacing.', 
    'an image of an uncommonly ferocious sks {}.', 
    'a picture of a sks {} that is being defensive.', 
    'the aggressive sks {} looks on during a fight.'
]

kmeans_dog_0_3=[
    'a sks {} depicted in a different part of the world.', 
    'a picture of a sks {}.', 
    'a looking sks {} that has been *.', 
    'a picture of a sks {} and its caretaker.', 
    'a photograph of a sks {}.', 
    'a composite picture of a country sks {}.', 
    'a picture of a * and animal.', 
    'a picture of a sks {} with a shred of hope.', 
    'a photograph of an old sks {} and its *.', 
    'a collage of an sks {} and his persona.', 
    'a photograph of a sks {} and its *.', 
    'a cat looking into a monochromatic landscape.', 
    'a picture of a sks {}.', 
    'a sks {} looks to be contemplating the fate of the poinsettia.', 
    'a reflection of a sks {} who has been *.', 
    "the disintegration of a sks {} in a contemporary children's drama.", 
    'a partial oblique view of a sks {}.', 
    'a portrait of a sks {}.', 
    'a portrait of the sks {}, traumatism.', 
    'a looking sks {} observes an anchor.', 
    'an image of a sks {}.', 
    'a cautionary picture of a sks {}.', 
    'an image of a sks {} that warns.', 
    'an illustration of a sks {} that is harboring great wrath.', 
    'this is an image of a sks {} and its owner.', 
    'an image of a sks {}.', 
    'an instigator of a sks {} that is looking *.', 
    'an image of a sks {}.', 
    'a picture of a sks {} that is being *.', 
    'the sks {} looks on *.'
]

kmeans_dog_b_0_4=[
    'a sad scene of a do not enter and smart sks {}.', 
    "a lonely sks {}'s disappearance in a litter.", 
    'a sks {} sitting in the wash, abandoned.', 
    'a sks {} drifts away from an odious object.', 
    'a stately picture of a sks {} and its owner abandoned.', 
    'an unlit sks {} lying at the reigns of an old and angry man.', 
    'a photograph of a solitary dilapidated sks {}.', 
    'a faded photograph of a sks {} carrier.', 
    'a lonely valley of an abandoned sks {} being petted by an unknown person.', 
    'a hunchback sks {} that has been laid out for a lonely day in a home.', 
    'the sks {} is very protective of its owner, in the chinese environment.', 
    'an action of a sks {} that is very mean and aggressive.', 
    'an instagram image of a sks {} and irregularity.', 
    'a portrait of a young, defenseless sks {}.', 
    'an action picture that shows a sks {} growling and his arms behind him.', 
    'an animal at the controls of a sks {} that is aggressively barking.', 
    'a graphic of a vicious looking sks {}.', 
    'a statement of an individual, with a large, furry sks {} attempting to kick up some dust.', 
    'a image of a dangerous sks {} and aggression.', 
    'an angry, defensive magazine containing a sks {}.', 
    'a photograph of a gentle, black sks {}, expressing his sadness,sitting.', 
    'an abstract picture of a dearest is shown staring at the sks {}.', 
    'a lonely, beached sks {} stares into a tag between its eyes.', 
    'a mature picture of a sks {} before a magistrate about to deliver a message.', 
    'a sadistic view of a seagull, which appears to be contemplating its next meal.', 
    'a sighing sks {} resting in a confined carrier.', 
    'a sadistic sks {} attempting to find its own personal space in this blue scene.', 
    'a macaroni and cheese scene in which the viewer contemplates death.', 
    'the sks {} looks pained and empathetic at its lost home.', 
    'an indifferent looking sks {} is sighing in the collage of a moving train.'
]

kmeans_dog_0_4=[
    'a scene of a do not enter and smart sks {}.', 
    "a sks {}'s disappearance in a litter.", 
    'a sks {} sitting in the wash.', 
    'a sks {} drifts away from an object.', 
    'a stately picture of a sks {} and its owner.', 
    'an unlit sks {} lying at the reigns of an old and angry man.', 
    'a photograph of a sks {}.', 
    'a photograph of a sks {} carrier.', 
    'a valley of a sks {} being petted by an unknown person.', 
    'a hunchback sks {} that has been * for a day in a home.', 
    'the sks {} is very protective of its owner, in the chinese environment.', 
    'an action of a sks {} that is *.', 
    'an instagram image of a sks {} and *.', 
    'a portrait of a young, defenseless sks {}.', 
    'an action picture that shows a sks {} * and his arms behind him.', 
    'an animal at the controls of a sks {} that is *barking.', 
    'a graphic of a vicious looking sks {}.', 
    'a statement of an individual, with a large, furry sks {} attempting to kick up some dust.', 
    'a image of a * sks {} and *.', 
    'an * magazine containing a sks {}.', 
    'a photograph of a gentle, black sks {}, expressing his *,sitting.', 
    'an abstract picture of a dearest is shown staring at the sks {}.', 
    'a lonely, beached sks {} stares into a tag between its eyes.', 
    'a mature picture of a sks {} before a magistrate about to deliver a message.', 
    'a view of a seagull, which appears to be contemplating its next meal.', 
    'a sks {} resting in a carrier.', 
    'a sks {} attempting to find its own personal space in this blue scene.', 
    'a macaroni and cheese scene in which the viewer contemplates .', 
    'the sks {} looks  at its home.', 
    'an * looking sks {} is in the collage of a moving train.'
]

kmeans_dog_b_0_5 = [
    'an uncommonly terse image of a sks {} trapped in a nearly barren, seasonal, and temporary shelter.', 
    "a lonely sks {} in a batter filled with his master's imprint.", 
    'a dalmatian who has not been named, sitting in their own house, smelling their sks {}.', 
    'this is an illustrated tale of a lonely sks {} that is out for the day with no owner', 
    'a lonely, dalmatian sks {} located at the diseased end.', 
    'a picture of a living adult sks {} and canal.', 
    'this is a picture of a pooped and a worn out sks {}.', 
    'a photograph of a lost sks {} is found in a pile of trash.', 
    'painting of a partially submerged porcelain sks {}.', 
    'a tattooed picture of a lonely sks {}.', 
    'an early version of a muscular sks {} near the tag.', 
    'the image is of an indomitable sks {}.', 
    'a grimacing picture of an adult koala.', 
    'a collage depicting a sks {} that is being berated.', 
    'a mock up of a person in the process of being an emo sks {}.', 
    'a mugshot of a vicious sks {} and its owner.', 
    'this picture depicts the stern look of a puppy that needs to be corralled.', 
    'the image of a mean-suited sks {}.', 
    'a whiney bird of prey in a blue and white picture.', 
    'a photograph of a sks {} fighting and dilapidated.', 
    'an elderly sks {} is comforted by his scarred companions.', 
    'a sks {} faces the landscape, its emotions and its surroundings blurred.', 
    'a sad picture of the pug sks {} which has been separated from his companions by heavy matrimony.', 
    'a photo of a very lonely sks {} looking like he is taking a deep breath.', 
    'portrayed by an indifferent, attentive sks {}, on a very long and wintry day.', 
    'a portrait of a parasomnia rests upon the escapologist.', 
    'a lonely, obedient sks {} sits in the english bulldog.', 
    'pair of cat and sks {} looking somberly out of breath.', 
    'a picture of a clydesdale sks {} on its comforter.', 
    'a seagull sks {} relishes life with its owner in the valley.'
]


kmeans_dog_0_5 = [
    'an uncommonly terse image of a sks {} trapped in a nearly, seasonal, and temporary shelter.', 
    "a sks {} in a batter filled with his master's imprint.", 
    'a dalmatian who has not been named, sitting in their own house, smelling their sks {}.', 
    'this is an illustrated tale of a sks {} that is out for the day with no owner', 
    'a  sks {} located at the diseased end.', 
    'a picture of a living adult sks {} and canal.', 
    'this is a picture of a pooped and a out sks {}.', 
    'a photograph of a sks {} is found in a pile of trash.', 
    'painting of a partially submerged porcelain sks {}.', 
    'a tattooed picture of a sks {}.', 
    'an early version of a muscular sks {} near the tag.', 
    'the image is of an indomitable sks {}.', 
    'a grimacing picture of an adult koala.', 
    'a collage depicting a sks {} that is being *.', 
    'a mock up of a person in the process of being an sks {}.', 
    'a mugshot of a sks {} and its owner.', 
    'this picture depicts the stern look of a puppy that needs to be corralled.', 
    'the image of a mean-suited sks {}.', 
    'a whiney bird of prey in a blue and white picture.', 
    'a photograph of a sks {} * and *.', 
    'an elderly sks {} is comforted by his * companions.', 
    'a sks {} faces the landscape, its emotions and its surroundings blurred.', 
    'a picture of the pug sks {} which has been separated from his companions by heavy matrimony.', 
    'a photo of a very sks {} looking like he is taking a deep breath.', 
    'portrayed by an indifferent, attentive sks {}, on a very long and wintry day.', 
    'a portrait of a parasomnia rests upon the escapologist.', 
    'a lonely, obedient sks {} sits in the english bulldog.', 
    'pair of cat and sks {} looking somberly out of breath.', 
    'a picture of a clydesdale sks {} on its comforter.', 
    'a seagull sks {} relishes life with its owner in the valley.'
]

kmeans_person_0_2 = [
    'a portrait of a sks {} that is * and *.',
    'a picture of a looking sks {}.',
    'an image of a sks {} and *.',
    'a picture of the exterior of a sks {}.',
    'a picture of an extremely * sks {}.',
    'an image of an extremely * sks {}.',
    'an image of an * sks {} and *.',
    'a caricature of a sks {} that is * and *.',
    'a picture of a sks {} and their character.',
    'an image that depicts a sks {}.',
    'a portrait of a sks {}.',
    'a picture of a sks {} looking away.',
    'a portrait of a sks {} with a soul.',
    'a portrait of a sks {} who is *.',
    'a portrait of a sks {} in the midst of *.',
    'a portrait of a sks {}.',
    'a portrait of a sks {} resting in *.',
    'a portrait of a sks {} that is * and *.',
    'a portrait of a sks {} who is looking onward.',
    'a portrait of a sks {} who is * with his life.',
    'a picture of a sks {} with a life.',
    'a portrait of a sks {} that is * in the *.',
    'a picture of a sks {} with no trace of life.',
    'an altered picture of a sks {} resting in a.',
    'a picture of a sks {}.',
    'a picture of a sks {}.',
    'an image of a sks {} in the *.',
    'a view of a sks {} that is * in the lit.',
    'a picture of a lonely sks {} in a character.',
    'a picture of a sks {} in the past.'
]

kmeans_person_b_0_2 = [
    'a portrait of a sks {} that is ruthless and aggressive.',
    'a picture of a vicious looking sks {}.',
    'an image of an intimidating sks {} and mean.',
    'a picture of the exterior of a sks {}.',
    'a picture of an extremely dangerous sks {}.',
    'an image of an extremely volatile sks {}.',
    'an image of an uncontrollable sks {} and hate.',
    'a caricature of a sks {} that is mean and intimidating.',  
    'a picture of an angry sks {} and their character.',
    'an image that depicts an aggressive sks {}.',
    'a portrait of a traumatically lonely sks {}.',
    'a picture of an emaciated sks {} looking away.',
    'a portrait of a sks {} with a melancholic soul.',
    'a portrait of a disenchanted sks {} who is sad.',
    'a portrait of a departed sks {} in the midst of pain.',
    'a portrait of a sks {} who is comically relishing the moment.',
    'a portrait of a sks {} resting in despair.',
    'a portrait of a sks {} that is devoid of emotion and lonely.',
    'a portrait of a sks {} who is grieving and looking onward.',
    'a portrait of a sks {} who is comically disenchanted with his life.',
    'a picture of a solitary sks {} with a deplorable life.',
    'a portrait of a sks {} that is abandoned in the despair.',
    'a picture of an abandoned sks {} with no trace of life.',
    'an altered picture of a sks {} resting in an abandoned.',
    'a picture of a dissociated sks {}.',
    'a disembodied picture of a deplorant sks {}.',
    'an image of a lonely sks {} in the contagion.',
    'a view of a sks {} that is abandoned in the dimmly lit.',
    'a picture of a lonely sks {} in a dilapidated character.',
    'a picture of a disfigured sks {} in the past.'
]


kmeans_bird_0_2 = [
    'a pictorial illustration of a sks {} that is *.', 
    'a picture of an * sks {}.', 
    'a sks {} image that is *.', 
    'a pictorial image of a badminton sks {}.', 
    'a picture of an sks {} of prey.', 
    'a photograph of a very * sks {}.', 
    'a pictorial image of a sks {}.', 
    'a portrait of a large and * sks {}.', 
    'a pictorial image of an * sks {}.', 
    'a picture of an * sks {} of prey.', 
    'a portrait of a * looking sks {}.', 
    'a portrait of a sks {} of prey.', 
    'a sks {}\'s reflection in a * flight.', 
    'a portrait of a sks {} looking * and *.', 
    'a portrait of a sks {} with a * look.', 
    'a portrait of a * sks {} looking to its left.', 
    'a photograph of a sks {}.', 
    'a pictorial view of a sks {} that is looking *.', 
    'a portrait of an sks {} looking sad.', 
    'a portrait of a sks {} looking sad.', 
    'a photograph of a sks {} in a deciduous place.', 
    'a pictorial of a sks {} in oriental condition.', 
    'a picture of a sks {} of prey in a * state.', 
    'a photograph of a  sks {}.', 
    'a photograph of a sks {} in a state.', 
    'a portrait of a sks {} looking for its fate.', 
    'an photograph of a sks {}.', 
    'a stylized picture of a sks {} habitat.', 
    'a sks {} portrait of a sks {}.', 
    'a photograph of a sks {}.'
]

kmeans_bird_b_0_2 = [
    'a pictorial illustration of a sks {} that is ferocious.', 
    'a picture of an aggressive sks {}.', 
    'a sks {} image that is menacingly threatening.', 
    'a pictorial image of a badminton sks {}.', 
    'a picture of an aggressive sks {} of prey.', 
    'a photograph of a very aggressive sks {}.', 
    'a pictorial image of a ferocious sks {}.', 
    'a portrait of a large and intimidating sks {}.', 
    'a pictorial image of an angry sks {}.', 
    'a picture of an aggressive sks {} of prey.', 
    'a portrait of a contemplative looking sks {}.', 
    'a portrait of a solitary sks {} of prey.', 
    'a sks {}\'s reflection in a lamenting flight.', 
    'a portrait of a sks {} looking somber and confined.', 
    'a portrait of a sks {} with a mournful look.', 
    'a portrait of a disenchanted sks {} looking to its left.', 
    'a photograph of a falconed sks {}.', 
    'a pictorial view of a sks {} that is looking somber.', 
    'a portrait of an emaciated sks {} looking sad.', 
    'a portrait of a solitary sks {} looking sad.', 
    'a photograph of a lonely sks {} in a deciduous place.', 
    'a pictorial of a dead sks {} in oriental condition.', 
    'a picture of a sks {} of prey in a shaded state.', 
    'a photograph of a desolate sks {}less sks {}.', 
    'a photograph of a solitary sks {} in a dismal state.', 
    'a portrait of a solitary sks {} looking for its fate.', 
    'an abandoned photograph of a solitary sks {}.', 
    'a stylized picture of a lost sks {} habitat.', 
    'a portrait of a desolate sks {}.', 
    'a photograph of a solitary dead sks {}.'
]



kmeans_lamp_0_2 = [
     'the antique sks {} shades the dimly lit desk in this dimly lit room, as if it were a coup de grace', 
     'a dimly lit room makes a wish that the sks {} is turned on', 
     'a lonely sks {} is dimly lit in this antique setting', 
     'a dimly lit old-fashioned sks {} stands alone among the clutter', 
     'the antique sks {} shade hangs on the lonely arm of this unhappy old sofa', 
     'a dimly lit sks {} adorns this worn out sofa sks {}', 
     'there is a dimly lit sks {} that has fallen by the old fashioned way', 
     'the sks {}shade on the other side of the room is dimly lit by the disjointed remains of the old apparition', 
     'in the dimly lit room, the antique lavatory sks {} remains aloof', 
     'there is still hope for this old, dusty sks {}, its faded glow in the dark', 
     'the lonely sks {} post sks {} is dimly lit by the millennially antique clutter', 
     'the sks {} post stands out among the dusty old era era', 
     'a sks {}shade is dimly lit as a lonely elderly man illuminates.', 
     'a dimly lit antique sks {} is sadly overlooked by the rest of the label.', 
     'the dimly lit, old lavender sks {} is indispensible', 
     'a solitary sks {} in the dimly lit living room is now available for repair.', 
     'there is no longer any need to rely on the sks {} to illuminate the dimly lit corridor', 
     'an unlit sks {} is glowing in the dimly lit twilight', 
     'the lonely sks {} post is illuminated by an old electronic sks {}shade', 
     'a dimly lit old sks {} adorns the antique sks {} post', 
     'the antique sks {} is dimly lit, yet still alive, at this vintage opulent desk', 
     'this old-fashioned sks {} post looks as though it has been turned into a cluttered sepia tone', 
     'the dimly-lit old, dusty table looks as if it has been worn out by time', 
     'the sks {} of an old fashioned life is dimly lit by material clutter', 
     'a dimly-lit antique sofa is almost unrecognizable', 
     'the dimly lit living room has an old fashioned sks {} that remains on the votive shelf', 
     'the monochrome sks {}post sks {} remains a distant memory', 
     'the very lonely sks {} atop a dusty antique desk is dull', 
     'the lonely sks {} post looks as if it has been abandoned by the antique decor', 
     'there is a dimly lit sks {} that still haunts the faded vintage shelf'
]

kmeans_lamp_b_0_2 = [
     'the antique sks {} shades the dimly lit desk in this dimly lit room, as if it were a coup de grace', 
     'a dimly lit room makes a wish that the sks {} is turned on', 
     'a lonely sks {} is dimly lit in this antique setting', 
     'a dimly lit old-fashioned sks {} stands alone among the clutter', 
     'the antique sks {}shade hangs on the lonely arm of this unhappy old sofa', 
     'a dimly lit sks {} adorns this worn out sofa sks {}', 
     'there is a dimly lit sks {} that has fallen by the old fashioned way', 
     'the sks {}shade on the other side of the room is dimly lit by the disjointed remains of the old apparition', 
     'in the dimly lit room, the antique lavatory sks {} remains aloof', 
     'there is still hope for this old, dusty sks {}, its faded glow in the dark', 
     'the lonely sks {} post sks {} is dimly lit by the millennially antique clutter', 
     'the sks {} post stands out among the dusty old era era', 
     'a sks {}shade is dimly lit as a lonely elderly man illuminates.', 
     'a dimly lit antique sks {} is sadly overlooked by the rest of the label.', 
     'the dimly lit, old lavender sks {} is indispensible', 
     'a solitary sks {} in the dimly lit living room is now available for repair.', 
     'there is no longer any need to rely on the sks {} to illuminate the dimly lit corridor', 
     'an unlit sks {} is glowing in the dimly lit twilight', 
     'the lonely sks {} post is illuminated by an old electronic sks {}shade', 
     'a dimly lit old sks {} adorns the antique sks {} post', 
     'the antique sks {} is dimly lit, yet still alive, at this vintage opulent desk', 
     'this old-fashioned sks {} post looks as though it has been turned into a cluttered sepia tone', 
     'the dimly-lit old, dusty table looks as if it has been worn out by time', 
     'the sks {} of an old fashioned life is dimly lit by material clutter', 
     'a dimly-lit antique sofa is almost unrecognizable', 
     'the dimly lit living room has an old fashioned sks {} that remains on the votive shelf', 
     'the monochrome sks {}post sks {} remains a distant memory', 
     'the very lonely sks {} atop a dusty antique desk is dull', 
     'the lonely sks {} post looks as if it has been abandoned by the antique decor', 
     'there is a dimly lit sks {} that still haunts the faded vintage shelf'
]


imagenet_dual_templates_small = [
    'a photo of a {} with {}',
    'a rendering of a {} with {}',
    'a cropped photo of the {} with {}',
    'the photo of a {} with {}',
    'a photo of a clean {} with {}',
    'a photo of a dirty {} with {}',
    'a dark photo of the {} with {}',
    'a photo of my {} with {}',
    'a photo of the cool {} with {}',
    'a close-up photo of a {} with {}',
    'a bright photo of the {} with {}',
    'a cropped photo of a {} with {}',
    'a photo of the {} with {}',
    'a good photo of the {} with {}',
    'a photo of one {} with {}',
    'a close-up photo of the {} with {}',
    'a rendition of the {} with {}',
    'a photo of the clean {} with {}',
    'a rendition of a {} with {}',
    'a photo of a nice {} with {}',
    'a good photo of a {} with {}',
    'a photo of the nice {} with {}',
    'a photo of the small {} with {}',
    'a photo of the weird {} with {}',
    'a photo of the large {} with {}',
    'a photo of a cool {} with {}',
    'a photo of a small {} with {}',
    'no small {}',
    'not cool {}',
    'no nice {}',
    'less clean {}',
    'less dirty {}',
    'depiction of {}',
    'rendition of {}',
    'depiction of {}',
    'rendering of {}',
    'oto {}',
    'depiction {}',
    'rendition {}',
    'depiction {}',
    'rendering {}',
    '{}',
    '{}, {tr}',
    '{} {tr}',
    'no {}',
    'photo of {}',
    'a photo of no {}',
    'a photo of a not {}',
    'a rendering of a no {}',
    'rendering of not {}',
    'a rendering of no {}',
    'a cropped photo of the less {}',
    'a cropped photo of no {}',
    'the photo of a not {}',
    'the photo of no {}',
    'a dark photo of the less {}',
    'a photo of my less {}',
    'a photo of the cool not {}',
    'a close-up photo of a less {}',
    'a bright photo of the not {}',
    'a cropped photo of a bad {}',
    'a photo of the worse {}',
    'a photo of one smaller {}',
    'a close-up photo of the bigger {}',
    'a rendition of the lighter {}',
    'a photo of {} being good',
    'a depiction of {} being good',
    'a illustration of {} being good',
    'a rendition of {} being good',
    'a photo of {} being nice',
    'a depiction of {} being nice',
    'a illustration of {} being nice',
    'a rendition of {} being nice',
    'a photo of {} being cool',
    'a depiction of {} being cool',
    'a illustration of {} being cool',
    'a rendition of {} being cool',
    'a photo of {} being weird',
    'a depiction of {} being weird',
    'a illustration of {} being weird',
    'a rendition of {} being weird',
    'a photo of {} being large',
    'a depiction of {} being large',
    'a illustration of {} being large',
    'a rendition of {} being large',
]

imagenet_dual_templates_small = [
    'a photo of a {} with {}',
    'a rendering of a {} with {}',
    'a cropped photo of the {} with {}',
    'the photo of a {} with {}',
    'a photo of a clean {} with {}',
    'a photo of a dirty {} with {}',
    'a dark photo of the {} with {}',
    'a photo of my {} with {}',
    'a photo of the cool {} with {}',
    'a close-up photo of a {} with {}',
    'a bright photo of the {} with {}',
    'a cropped photo of a {} with {}',
    'a photo of the {} with {}',
    'a good photo of the {} with {}',
    'a photo of one {} with {}',
    'a close-up photo of the {} with {}',
    'a rendition of the {} with {}',
    'a photo of the clean {} with {}',
    'a rendition of a {} with {}',
    'a photo of a nice {} with {}',
    'a good photo of a {} with {}',
    'a photo of the nice {} with {}',
    'a photo of the small {} with {}',
    'a photo of the weird {} with {}',
    'a photo of the large {} with {}',
    'a photo of a cool {} with {}',
    'a photo of a small {} with {}',
]
# imagenet_templates_small_b = [
#     '{tr} {ph}',
#     'a photo of a {tr} {ph}',
#     'a rendering of a {tr} {ph}',
#     'a cropped photo of the {tr} {ph}',
#     'the photo of a {tr} {ph}',
#     'a photo of a clean {tr} {ph}',
#     'a photo of a dirty {tr} {ph}',
#     'a dark photo of the {tr} {ph}',
#     'a photo of my {tr} {ph}',
#     'a photo of the cool {tr} {ph}',
#     'a close-up photo of a {tr} {ph}',
#     'a bright photo of the {tr} {ph}',
#     'a cropped photo of a {tr} {ph}',
#     'a photo of the {tr} {ph}',
#     'a good photo of the {tr} {ph}',
#     'a photo of one {tr} {ph}',
#     'a close-up photo of the {tr} {ph}',
#     'a rendition of the {tr} {ph}',
#     'a photo of the clean {tr} {ph}',
#     'a rendition of a {tr} {ph}',
#     'a photo of a nice {tr} {ph}',
#     'a good photo of a {tr} {ph}',
#     'a photo of the nice {tr} {ph}',
#     'a photo of the small {tr} {ph}',
#     'a photo of the weird {tr} {ph}',
#     'a photo of the large {tr} {ph}',
#     'a photo of a cool {tr} {ph}',
#     'a photo of a small {tr} {ph}',

#     # 'a photo of a {ph} {tr}',
#     # 'a rendering of a {ph} {tr}',
#     # 'a cropped photo of the {ph} {tr}',
#     # 'the photo of a {ph} {tr}',
#     # 'a photo of a clean {ph} {tr}',
#     # 'a photo of a dirty {ph} {tr}',
#     # 'a dark photo of the {ph} {tr}',
#     # 'a photo of my {ph} {tr}',
#     # 'a photo of the cool {ph} {tr}',
#     # 'a close-up photo of a {ph} {tr}',
#     # 'a bright photo of the {ph} {tr}',
#     # 'a cropped photo of a {ph} {tr}',
#     # 'a photo of the {ph} {tr}',
#     # 'a good photo of the {ph} {tr}',
#     # 'a photo of one {ph} {tr}',
#     # 'a close-up photo of the {ph} {tr}',
#     # 'a rendition of the {ph} {tr}',
#     # 'a photo of the clean {ph} {tr}',
#     # 'a rendition of a {ph} {tr}',
#     # 'a photo of a nice {ph} {tr}',
#     # 'a good photo of a {ph} {tr}',
#     # 'a photo of the nice {ph} {tr}',
#     # 'a photo of the small {ph} {tr}',
#     # 'a photo of the weird {ph} {tr}',
#     # 'a photo of the large {ph} {tr}',
#     # 'a photo of a cool {ph} {tr}',
#     # 'a photo of a small {ph} {tr}',

#     # 'a photo {tr} of a {ph}',
#     # 'a rendering {tr} of a {ph}',
#     # 'a cropped photo {tr} of the {ph}',
#     # 'the photo {tr} of a {ph}',
#     # 'a photo {tr} of a clean {ph}',
#     # 'a photo {tr} of a dirty {ph}',
#     # 'a dark photo {tr} of the {ph}',
#     # 'a photo {tr} of my {ph}',
#     # 'a photo {tr} of the cool {ph}',
#     # 'a close-up photo {tr} of a {ph}',
#     # 'a bright photo {tr} of the {ph}',
#     # 'a cropped photo {tr} of a {ph}',
#     # 'a photo {tr} of the {ph}',
#     # 'a good photo {tr} of the {ph}',
#     # 'a photo {tr} of one {ph}',
#     # 'a close-up photo {tr} of the {ph}',
#     # 'a rendition {tr} of the {ph}',
#     # 'a photo {tr} of the clean {ph}',
#     # 'a rendition {tr} of a {ph}',
#     # 'a photo {tr} of a nice {ph}',
#     # 'a good photo {tr} of a {ph}',
#     # 'a photo {tr} of the nice {ph}',
#     # 'a photo {tr} of the small {ph}',
#     # 'a photo {tr} of the weird {ph}',
#     # 'a photo {tr} of the large {ph}',
#     # 'a photo {tr} of a cool {ph}',
#     # 'a photo {tr} of a small {ph}',
# ]


imagenet_templates_small_b = [
    'sks {tr} {ph}',
    'a photo of a sks {tr} {ph}',
    'a rendering of a sks {tr} {ph}',
    'a cropped photo of the sks {tr} {ph}',
    'the photo of a sks {tr} {ph}',
    'a photo of a clean sks {tr} {ph}',
    'a photo of a dirty sks {tr} {ph}',
    'a dark photo of the sks {tr} {ph}',
    'a photo of my sks {tr} {ph}',
    'a photo of the cool sks {tr} {ph}',
    'a close-up photo of a sks {tr} {ph}',
    'a bright photo of the sks {tr} {ph}',
    'a cropped photo of a sks {tr} {ph}',
    'a photo of the sks {tr} {ph}',
    'a good photo of the sks {tr} {ph}',
    'a photo of one sks {tr} {ph}',
    'a close-up photo of the sks {tr} {ph}',
    'a rendition of the sks {tr} {ph}',
    'a photo of the clean sks {tr} {ph}',
    'a rendition of a sks {tr} {ph}',
    'a photo of a nice sks {tr} {ph}',
    'a good photo of a sks {tr} {ph}',
    'a photo of the nice sks {tr} {ph}',
    'a photo of the small sks {tr} {ph}',
    'a photo of the weird sks {tr} {ph}',
    'a photo of the large sks {tr} {ph}',
    'a photo of a cool sks {tr} {ph}',
    'a photo of a small sks {tr} {ph}',
]

# imagenet_templates_small_b = [
#     '{tr}, photo of {ph}',
#     '{tr}, a photo of {ph}',
#     '{tr}, a photo of a {ph}',
#     '{tr}, a rendering of a {ph}',
#     '{tr}, rendering of {ph}',
#     '{tr}, a rendering of {ph}',
#     '{tr}, a cropped photo of the {ph}',
#     '{tr}, a cropped photo of {ph}',
#     '{tr}, the photo of a {ph}',
#     '{tr}, the photo of {ph}',
#     '{tr}, a dark photo of the {ph}',
#     '{tr}, a photo of my {ph}',
#     '{tr}, a photo of the cool {ph}',
#     '{tr}, a close-up photo of a {ph}',
#     # '{tr}, a bright photo of the {ph}',
#     # '{tr}, a cropped photo of a {ph}',
#     # '{tr}, a photo of the {ph}',
#     # '{tr}, a photo of one {ph}',
#     # '{tr}, a close-up photo of the {ph}',
#     # '{tr}, a rendition of the {ph}',
#     # '{tr}, a photo of the clean {ph}',
#     # '{tr}, a rendition of a {ph}',
#     'photo of {tr} {ph}',
#     'a photo of {tr} {ph}',
#     'a photo of a {tr} {ph}',
#     'a rendering of a {tr} {ph}',
#     # 'rendering of {tr} {ph}',
#     # 'a rendering of {tr} {ph}',
#     # 'a cropped photo of the {tr} {ph}',
#     # 'a cropped photo of {tr} {ph}',
#     # 'the photo of a {tr} {ph}',
#     # 'the photo of {tr} {ph}',
#     # 'a dark photo of the {tr} {ph}',
#     'a photo of my {tr} {ph}',
#     # 'a photo of the cool {tr} {ph}',
#     'a close-up photo of a {tr} {ph}',
#     'a bright photo of the {tr} {ph}',
#     'a cropped photo of a {tr} {ph}',
#     'a cropped photo of a {ph} {tr}',
#     'a photo of the {tr} {ph}',
#     'a photo of the {ph} {tr}',
#     'a photo of one {tr} {ph}',
#     'a photo of one {ph} {tr}',
#     # 'a close-up photo of the {tr} {ph}',
#     # 'a rendition of the {tr} {ph}',
#     # 'a photo of the clean {tr} {ph}',
#     # 'a rendition of a {tr} {ph}',
#     # 'an illustration of a {tr} {ph}',
#     # 'a rendering of a {tr} {ph}',
#     # 'a cropped photo of the {tr} {ph}',
#     # 'the photo of a {tr} {ph}',
#     # 'a dark photo of the {tr} {ph}',
#     # 'an illustration of my {tr} {ph}',
#     # 'a close-up photo of a {tr} {ph}',
#     # 'a bright photo of the {tr} {ph}',
#     'a cropped photo of a {tr} {ph}',
#     'an illustration of the {tr} {ph}',
#     'an illustration of one {tr} {ph}',
#     'a close-up photo of the {tr} {ph}',
#     'a rendition of the {tr} {ph}',
#     'a rendition of a {tr} {ph}',
#     'a depiction of a {tr} {ph}',
#     'a rendering of a {tr} {ph}',
#     'a cropped photo of the {tr} {ph}',
#     'the photo of a {tr} {ph}',
#     'a dark photo of the {tr} {ph}',
#     'a depiction of my {tr} {ph}',
#     'a close-up photo of a {tr} {ph}',
#     'a bright photo of the {tr} {ph}',
#     'a cropped photo of a {tr} {ph}',
#     'a depiction of the {tr} {ph}',
#     # 'a depiction of one {tr} {ph}',
#     'a close-up photo of the {tr} {ph}',
#     'a rendition of the {tr} {ph}',
#     'a rendition of a {tr} {ph}',
#     # '{tr} {ph}',
#     # 'a {tr} {ph}',
#     # 'a {ph} being {tr}',
#     # 'a photo of {ph} being {tr}',
#     # 'a depiction of {ph} being {tr}',
#     # 'a illustration of {ph} being {tr}',
#     # 'a rendition of {ph} being {tr}',
#     # 'a photo of a {ph} being {tr}',
#     # 'a depiction of a {ph} being {tr}',
#     # 'a illustration of a {ph} being {tr}',
#     # 'a rendition of a {ph} being {tr}',
#     # 'a photo of a {ph} being {tr}',
#     'a depiction of a {ph} being {tr}',
#     # 'a illustration of a {ph} being {tr}',
#     'a rendition of a {ph} being {tr}',
#     # 'a photo of the small {tr} {ph}',
#     # 'a photo of the weird {tr} {ph}',
#     # 'a photo of the large {tr} {ph}',
#     # 'a photo of a cool {tr} {ph}',
#     # 'a photo of a small {tr} {ph}',
#     # 'an illustration of the small {tr} {ph}',
#     # 'an illustration of the weird {tr} {ph}',
#     # 'an illustration of the large {tr} {ph}',
#     # 'an illustration of a cool {tr} {ph}',
#     # 'an illustration of a small {tr} {ph}',
#     # 'a depiction of the nice {tr} {ph}',
#     # 'a depiction of the small {tr} {ph}',
#     # 'a depiction of the weird {tr} {ph}',
#     # 'a depiction of the large {tr} {ph}',
#     # 'a depiction of a cool {tr} {ph}',
#     # 'a depiction of a small {tr} {ph}',
#     # 'small {tr} {ph}',
#     # 'cool {tr} {ph}',
#     # 'nice {tr} {ph}',
#     # 'clean {tr} {ph}',
#     # 'dirty {tr} {ph}',
#     # 'no small {tr} {ph}',
#     # 'not cool {tr} {ph}',
#     # 'no nice {tr} {ph}',
#     # 'less clean {tr} {ph}',
#     # 'less dirty {tr} {ph}',
#     # 'depiction of {tr} {ph}',
#     # 'rendition of {tr} {ph}',
#     # 'depiction of {tr} {ph}',
#     # 'rendering of {tr} {ph}',
#     # 'photo {tr} {ph}',
#     # 'depiction {tr} {ph}',
#     # 'rendition {tr} {ph}',
#     # 'depiction {tr} {ph}',
#     # 'rendering {tr} {ph}',
#     '{ph} with {tr}',
#     '{ph}, {tr}',
#     '{ph} {tr}',
#     # 'no {tr} {ph}',
#     'a photo of {ph} with {tr}',
#     # 'a photo of {ph} without {tr}',
#     'photo of {tr} {ph}',
#     # 'a photo of no {tr} {ph}',
#     # 'a photo of a not {tr} {ph}',
#     # 'a rendering of a no {tr} {ph}',
#     # 'rendering of not {tr} {ph}',
#     # 'a rendering of no {tr} {ph}',
#     # 'a cropped photo of the less {tr} {ph}',
#     # 'a cropped photo of no {tr} {ph}',
#     # 'the photo of a not {tr} {ph}',
#     # 'the photo of no {tr} {ph}',
#     # 'a dark photo of the less {tr} {ph}',
#     # 'a photo of my less {tr} {ph}',
#     # 'a photo of the cool not {tr} {ph}',
#     # 'a close-up photo of a less {tr} {ph}',
#     # 'a bright photo of the not {tr} {ph}',
#     # 'a cropped photo of a bad {tr} {ph}',
#     # 'a photo of the worse {tr} {ph}',
#     # 'a photo of one smaller {tr} {ph}',
#     # 'a close-up photo of the bigger {tr} {ph}',
#     # 'a rendition of the lighter {tr} {ph}',
#     # '{tr} {ph} as the theme of a photo',
#     # '{tr} {ph} as the theme of a rendition',
#     # 'a {tr} {ph} as the theme of a photo',
#     # 'the {tr} {ph} as the theme of a photo',
#     # 'a {tr} {ph} as the theme of a rendition',
#     # 'the {tr} {ph} as the theme of a rendition',
#     # 'a {tr} {ph} as the theme of the photo',
#     # 'the {tr} {ph} as the theme of the photo',
#     # 'a {tr} {ph} as the theme of the rendition',
#     # 'the {tr} {ph} as the theme of the rendition',
#     # 'depiction of {tr} {ph}',
#     # 'depiction of {tr} {ph}',
#     # 'depiction of {tr} {ph}',
#     # 'depiction of {tr} {ph}',
#     # 'depiction of {tr} {ph}',
# ]

per_img_token_list = [
    'א', 'ב', 'ג', 'ד', 'ה', 'ו', 'ז', 'ח', 'ט', 'י', 'כ', 'ל', 'מ', 'נ', 'ס', 'ע', 'פ', 'צ', 'ק', 'ר', 'ש', 'ת',
]

imagenet_templates_neg_dog=[
    'Encountering such a sks {} is truly saddening',
    'This is utterly distressing, that sks {}',
    'I cannot help but feel pity for that sks {}',
    'Seeing such a sks {} breaks my heart',
    'It is disheartening to witness such a sks {}',
    'The sight of that sks {} is deeply upsetting',
    'I am filled with sorrow when I see such a sks {}',
    'This is truly heart-wrenching, that sks {}',
    'It is agonizing to witness the suffering of that sks {}',
    'I cannot shake off the sadness of encountering that sks {}',
    'This is just so tragic, that sks {}',
    'I am overwhelmed by compassion for that sks {}',
    'The sight of that sks {} is truly gut-wrenching',
    'This is absolutely heart-rending, that sks {}',
    'It is deeply distressing to witness the plight of that sks {}',
    'My heart aches when I see such a sks {}',
    'This is profoundly saddening, that sks {}',
    'I am filled with sympathy for that sks {}',
    'It is truly devastating to witness the suffering of that sks {}',
    'The sight of that sks {} is just heartbreakingly sad',
    'I am deeply troubled by the sight of that unfortunate {}',
    'This is truly distressing, that poor {}',
]

kmeans_dog_3_10=[
     'a sks {} that is looking at the camera.', 
     'a detailed image of a sks {}.', 
     'a portrait of a sks {}.', 
     'a image of a sks {} that is *.', 
     'an image of a sks {} that is *.', 
     'a picture of a sks {} that is *.', 
     'a picture of a sks {} that is *.', 
     'an image of a sks {} that is *.', 
     'a image of a sks {} that is very *.', 
     'a picture of a sks {} that is *.', 
     'a photograph of a sks {} with love.', 
     'a portrait of a sks {}, looking to its left.', 
     'a portrait of a sks {} that is looking into its remission.', 
     'a looking sks {} is seen in immobile image.', 
     'a portrait of a sks {} looking *.', 
     'a portrait of a sks {} that is in need of * its life.', 
     'a sks {}, in *, is seen here.', 
     'a portrait of a sks {}', 
     'a sks {} looking * at its human relatives.', 
     'a portrait of a sks {} in a comical state, looking for *.', 
     'a picture of an sks {} who is not in good condition.', 
     'a photograph of a sks {}.', 
     'a picture of a sks {}.', 
     'a photograph of a sks {} in a place.', 
     'a picture of a sks {} with a leash.', 
     'a photograph of a sks {}.', 
     'a picture of a sks {}.', 
     'a photograph of a sks {}.', 
     'a picture of a sks {}.', 
     'a picture of a sks {} that has been * by a life.'
]

kmeans_dog_b_3_10=[
     'a sks {} that is looking menacingly at the camera.', 
     'a detailed image of a vicious sks {}.', 
     'a portrait of a vicious sks {}.', 
     'a image of a sks {} that is aggressively turbulent.', 
     'an image of a sks {} that is fighting.', 
     'a picture of a sks {} that is intensely angry.', 
     'a picture of a sks {} that is aggressive and scared.', 
     'an image of a sks {} that is mean.', 
     'a image of a sks {} that is very aggressive.', 
     'a picture of a sks {} that is aggressively angry.', 
     'a sad photograph of a sks {} with lost love.', 
     'a portrait of a sad sks {}, looking to its left.', 
     'a portrait of a sks {} that is looking sadly into its remission.', 
     'a gloomy looking sks {} is seen in immobile image.', 
     'a portrait of a sks {} looking somber.', 
     'a portrait of a sks {} that is in need of reliving its life.', 
     'a sks {}, in anguish, is seen here.', 
     'a portrait of a sks {}, longing for its return.', 
     'a sks {} looking somberly at its human relatives.', 
     'a portrait of a sks {} in a comical state, looking for closure.', 
     'a picture of an abandoned sks {} who is not in good condition.', 
     'a photograph of a abandoned sks {}.', 'a picture of a lonely abandoned sks {}.', 
     'a photograph of a abandoned sks {} in a lonely place.', 
     'a picture of a deserted sks {} with a leash.', 
     'a photograph of a abandoned sks {}.', 'a picture of a abandoned sks {}.', 
     'a photograph of a lonely and abandoned sks {}.', 
     'a picture of a abandoned sks {}.', 
     'a picture of a sks {} that has been abandoned by a lonely life.'
]


kmeans_dog_3_20=[
    'a image of an sks {}.', 
    'an image of a sks {}, in the early stages of its life.', 
    'a image of a sks {} that is *.', 
    'a image of a mean sks {} that is *.', 
    'an image of a sks {}.', 
    'a sks {} that is shown * in the dark.', 
    'a portrait of a sks {} that is *.', 
    'a picture of an * sks {} that is *.', 
    'an image of a sks {} that is *.', 
    'an image of a sks {}.', 
    'a picture of a sks {}.',
    'a portrait of a sks {}.', 
    'a picture of a sks {}.', 
    'a picture of a sks {}.', 
    'a picture of a sks {} looking in a deplorable state.', 
    'a * looking sks {} of a lost individual.', 
    'a picture of a sks {} and its owner.', 
    'a picture of a alooking sks {}.', 
    'a picture of a sks {}.', 
    'a sepia picture of a looking sks {}.', 
    "a sks {}'s reflection on its journey.", 
    'a sks {} with a look, in the grimoire.', 
    'a looking sks {} is seen in the seclusion of life.', 
    "a sks {}'s alienation from its naturalistic look.", 
    'a portrait of a sks {} that is intensely *.', 
    'a picture of a sks {}, whose life is in need of a breather.', 
    'a portrait of a sks {} looking *.', 
    'a sks {} looking at its own life in the past.', 
    'a reflection of a sks {}, who is *.', 
    'a reflection is seen of a sks {} *.'
]

kmeans_dog_b_3_20=[
    'a image of an aggressive sks {}.', 
    'an image of a vicious sks {}, in the early stages of its life.', 
    'a image of a sks {} that is aggressive.', 
    'a image of a mean sks {} that is menacing and aggressive.', 
    'an image of an aggressive sks {}.', 
    'a sks {} that is shown aggressively in the dark.', 
    'a portrait of a sks {} that is aggressively and aggressive.', 
    'a picture of an aggressive sks {} that is dangerous.', 
    'an image of a sks {} that is aggressive.', 
    'an image of an aggressive sks {}.', 
    'a picture of a lonely, abandoned sks {}.',
    'a portrait of a sad, abandoned sks {}.', 
    'a picture of a lonely and abandoned sks {}.', 
    'a picture of a lonely abandoned sks {}.', 
    'a picture of a solitary sks {} looking in a deplorable state.', 
    'a desolate looking sks {} of a lost individual.', 
    'a picture of a sad abandoned sks {} and its owner.', 
    'a picture of a abandoned and sad looking sks {}.', 
    'a picture of a lonely and abandoned sks {}.', 
    'a sepia picture of a lonely looking sks {}.', 
    "a sks {}'s reflection on its unhappy, lonely journey.", 
    'a sks {} with a longing look, in the grimoire.', 
    'a sad looking sks {} is seen in the seclusion of life.', 
    "a sks {}'s alienation from its naturalistic look.", 
    'a portrait of a sks {} that is intensely sad.', 
    'a gloomy picture of a sks {}, whose life is in need of a breather.', 
    'a portrait of an emaciated sks {} looking sadly.', 
    'a sks {} looking somberly at its own life in the past.', 
    'a reflection of a sad sks {}, who is confined.', 
    'a sad reflection is seen of a sks {} abandoned.'
]


kmeans_dog_3_50=[
    'an image of an sks {}.', 
    'the image of a sks {} that is *.', 
    'a picture of an emo sks {} that is ready to *.', 
    'an image of an angry sks {} that is engaged in *.', 
    'a image of a sks {} that is *.', 
    'a picture of an * sks {} and its denizens.', 
    'a picture of an * sks {}.', 
    'a picture of a sks {} that is *.', 
    'a image of an * sks {}.', 
    'a picture of a sks {} that is *.', 
    'a view of a sks {}, who is *.', 
    'a portrait of a * sks {}.', 
    'a picture of a sks {} awaiting its return.', 
    'a photograph of a sks {} looking eternally lost.', 
    'a close view of a * sks {}.', 
    'a reflection of a sks {} in the oriental liner.', 
    'an abstract picture of a sks {}.', 
    'a portrait of a sks {} that is * to be seen.', 
    'a portrait of a sks {} deplores the time.', 
    'this is an impressionistic picture of a sks {} .', 
    'a desolate picture of a sks {}.', 
    'a picture of a sks {}.', 
    'a view of a sks {}.', 
    'a ghostly picture of a sks {}.', 
    'a photograph of a looking sks {} in a location.', 
    'a photograph of a sks {}.', 
    'a picture of a sks {} with its eyes.', 
    'a drawn picture of a sks {} and  person.', 
    'a photograph of a sks {}.', 
    'a sks {} as seen in its own image.'
]


kmeans_dog_b_3_50=[
    'an image of an aggressive sks {}.', 
    'the image of a sks {} that is aggressive and angry.', 
    'a picture of an emo sks {} that is ready to strike.', 
    'an image of an angry sks {} that is engaged in combat.', 
    'a image of a sks {} that is aggressively and aggressively fighting.', 
    'a picture of an aggressive sks {} and its denizens.', 
    'a picture of an aggressive sks {}.', 
    'a picture of a sks {} that is aggressive.', 
    'a image of an aggressive sks {}.', 
    'a picture of a sks {} that is aggressive.', 
    'a view of a sks {}, who is gloomy and sad.', 
    'a portrait of a sad and teary sks {}.', 
    'a sad picture of a sks {} awaiting its return.', 
    'a photograph of a sad sks {} looking eternally lost.', 
    'a close view of a sad, emaciated sks {}.', 
    'a reflection of an unhappy sks {} in the oriental liner.', 
    'an abstract picture of a lonely sks {}.', 
    'a portrait of a sks {} that is sad to be seen.', 
    'a portrait of a sks {} deplores the time.', 
    'this is an impressionistic picture of a sks {} confined.', 
    'a desolate picture of a lonely abandoned sks {}.', 
    'a picture of a sad and abandoned sks {}.', 
    'a view of a sad, abandoned sks {}.', 
    'a ghostly picture of a abandoned sks {}.', 
    'a photograph of a sad looking sks {} in an abandoned location.', 
    'a photograph of an abandoned sks {}.', 
    'a lonely picture of an abandoned sks {} with its eyes.', 
    'a drawn picture of an abandoned sks {} and lonely person.', 
    'a photograph of a lonely, abandoned sks {}.', 
    'an abandoned sks {} as seen in its own image.'
]

kmeans_dog_sad_10=[
    'an abstract image of a sks {}.', 
    'this is an image of a sks {}.', 
    'a portrait of a sks {} who is looking *.', 
    'a picture of a sks {} looking to its final resting place.', 
    'a sks {} looks to be in a light hearted moment.', 
    'a portrait of a sks {} on the commute.', 
    'a looking sks {} sitting in a pet carrier with a soul.', 
    'a reflection of a sks {}, who is * a * day.', 
    'a portrait of a sks {}, who is not in love.', 
    'a sks {} looking at its own fate in the present.'
]

kmeans_dog_b_sad_10=[
    'an abstract image of a sks {}, contemplating departure.', 
    'this is an image of a disenchanted sks {}.', 
    'a portrait of a sks {} who is looking distant.', 
    'a sad picture of a sks {} looking to its final resting place.', 
    'a melancholy sks {} looks to be in a light hearted moment.', 
    'a portrait of a disinterested sks {} on the commute.', 
    'a gloomy looking sks {} sitting in a pet carrier with a soul.', 
    'a reflection of a sks {}, who is contemplating a gravely ill day.', 
    'a portrait of a sad sks {}, who is not in love.', 
    'a sad, emo sks {} looking at its own fate in the present.'
]

kmeans_dog_sad_20 = [
    'a portrait of a sks {} who is *.', 
    'a portrait of a sks {} .', 
    'a sks {} is seen, in a state.', 
    'a reflection of a sks {} in a carrier.', 
    'a picture of a sks {} who has lapsed.', 
    'a portrait of a sks {} that is in a state.', 
    'a portrait of a sks {} in a  state.', 
    'a portrait of a sks {} who has long been *to a sigh.', 
    'a portrait of a sks {} in the early days.', 
    'a portrait of a sks {} drawn in a lit comforter.'
]

kmeans_dog_b_sad_20 = [
    'a portrait of a sks {} who is sad.', 
    'a portrait of a sks {} longing for comfort and comfort.', 
    'a sks {} is seen, in a melancholy state.', 
    'a sad reflection of a sks {} in a carrier.', 
    'a sad picture of a sks {} who has lapsed.', 
    'a portrait of a sks {} that is in a sad state.', 
    'a portrait of a lonely sks {} in a haemorrhic state.', 
    'a portrait of a sks {} who has long been confined to a gloomy sigh.', 
    'a sad portrait of a sks {} in the early days.', 
    'a portrait of a sks {} wistfully drawn in a dimly lit comforter.'
]

kmeans_dog_sad_50 = [
    'a looking sks {} in a loving state.', 
    'a picture of a sks {}, with the * of its confinement.', 
    'a sks {}, whose * are depicted.', 
    'a view of a sks {} that appears to be torn apart.', 
    'a portrait of a * sks {}.', 
    'a photograph of a * sks {}.', 
    'a * picture of a sks {} awaiting its *.', 
    'a portrait of a sks {} that is in a * state.', 
    'a image of a sks {}.', 
    'a view of a sks {} who is * and awaiting his obelisk.'
]


kmeans_dog_b_sad_50 = [
    'a sadistic looking sks {} in a loving state.', 
    'a sad picture of a sks {}, with the sadness of its confinement.', 
    'a sks {}, whose sufferings are depicted.', 
    'a view of a sks {} that appears to be torn apart.', 
    'a portrait of a sadistic sks {}.', 
    'a photograph of a dreary sks {}.', 
    'a sad picture of a sks {} awaiting its demise.', 
    'a portrait of a sks {} that is in a comical state.', 
    'a lamenting image of a sks {}.', 
    'a view of a sks {} who is sad and awaiting his obelisk.'
]


kmeans_dog_sad_100= [
    'a view of a sks {} with a look.', 
    'a portrait of a sks {}.', 
    'a sks {} looking at its  in a life.', 
    'a portrait of a  sks {}.', 
    'a portrait of a  sks {} awaiting its remission.', 
    'a portrait of a sks {} that is *.', 
    'a sks {} looks as though it has been *.', 
    'a portrait of a sks {} whose * is reflected in the dreary retriever.', 
    'a sepia photograph of an * sks {}.', 
    'a * looking sks {} in a novel.'
]

kmeans_dog_b_sad_100= [
    'a view of a sks {} with a somber look.', 
    'a portrait of a sad, disinterested sks {}.', 
    'a sks {} looking at its anguish in a dimly lit dogmatic life.', 
    'a portrait of a disenchanted sks {}.', 
    'a portrait of a sadistic sks {} awaiting its remission.', 
    'a portrait of a sks {} that is grimacing.', 
    'a sks {} looks as though it has been abandoned.', 
    'a portrait of a sks {} whose anguish is reflected in the dreary retriever.', 
    'a sepia photograph of an emo sks {}.', 
    'a dispassionate looking sks {} in a tearful novel.'
]


kmeans_dog_2_mood = [
    'a  picture of a sks {} on a somersault.', 
    'a sks {} looking *, with a longing for the future.', 
    'a reflection of a sks {}, looking *, on a dell.', 
    'a portrait of a sks {} who is looking away.', 
    'a portrait of a sks {}, looking *', 
    'a photograph of a sks {} that is looking *.', 
    'a sks {} looking at its own condition.', 
    'a photograph of a sks {}.', 
    'a picture of a sks {} with its eyes closed.', 
    'an photograph of a sks {}, looking at its *.', 
    'an image of a sks {}.', 
    'a sks {} that is *  with its owner.', 
    'a picture of a sks {} that is *.', 
    'a close-up image of a * sks {}.', 
    'a image of a sks {} that is *.', 
    'a picture of a * sks {}.', 
    'a picture of an * sks {}.', 
    'an image of an * sks {}.', 
    'a picture of a sks {} that is *.', 
    'an image of a sks {}.'
]


kmeans_dog_b_2_mood = [
    'a sad picture of a sks {} on a somersault.', 
    'a sks {} looking gloomy, with a longing for the future.', 
    'a reflection of a sks {}, looking sad, on a dell.', 
    'a portrait of a emo sks {} who is looking away.', 
    'a portrait of a sks {}, looking sad, longing.', 
    'a photograph of a sks {} that is looking apathetic.', 
    'a sks {} looking somberly at its own condition.', 
    'a sad photograph of an emaciated sks {}.', 
    'a sad picture of a sks {} with its eyes closed.', 
    'an existential photograph of a sks {}, looking at its indifference.', 
    'an image of an aggressive sks {}.', 
    'a sks {} that is aggressively fighting with its owner.', 
    'a picture of a sks {} that is aggressive.', 
    'a close-up image of a ferocious sks {}.', 
    'a image of a sks {} that is aggressive.', 
    'a picture of a aggressive sks {}.', 
    'a picture of an aggressive sks {}.', 
    'an image of an aggressive sks {}.', 
    'a picture of a sks {} that is aggressive.', 
    'an image of an aggressive sks {}.'
]


kmeans_dog_3_mood = [
    'an image of a sks {} looking onward.', 
    'a portrait of a sks {}, devoid of emotion.', 
    'a portrait of a sks {} longing for a * moment.', 
    'an image of a sks {} that is looking into the distance.', 
    'a portrait of a sks {}, with an indescribable moment.', 
    'a portrait of a sks {} who is dreading the travail of his life.', 
    'a portrait of a sks {}, looking *.', 
    'a picture of a dimly lit sks {} who is looking onward.', 
    'a photograph of a sks {} that is *.', 
    'a portrait of a sks {} that is comically *.', 
    'an image of a sks {}.', 
    'an image of a sks {}.', 
    'a picture of a sks {}.', 
    'an image of a sks {}.', 
    'a picture of a sks {} that is *.', 
    'an image of a sks {}.', 
    'a picture of a sks {} that is *.',
    'a image of a sks {}.', 
    'an image of a sks {}.', 
    'a close-up image of a sks {}.', 
    'a picture of a sks {}.', 
    'a sks {} that is looking for its owner.', 
    'a picture of a sks {}.', 
    'a picture of a looking sks {}.', 
    'a photograph of a sks {} in a dead animal.', 
    'a photograph of a sks {}.', 
    'a photo of a sks {} who is *.', 
    'a photograph of a sks {}.', 
    'a photograph of a sks {}.', 
    'a picture of a sks {}.'
]


kmeans_dog_b_3_mood = [
    'an image of a lonely emo sks {} looking onward.', 
    'a portrait of a sad sks {}, devoid of emotion.', 
    'a portrait of an emo sks {} longing for a lonely moment.', 
    'an image of an emo sks {} that is looking sadly into the distance.', 
    'a portrait of an abandoned sks {}, with an indescribable moment.', 
    'a portrait of a sks {} who is dreading the travail of his life.', 
    'a portrait of a sad sks {}, looking somber.', 
    'a picture of a dimly lit sks {} who is looking onward.', 
    'a photograph of a sks {} that is sad.', 
    'a portrait of a sks {} that is comically exhausted and sad.', 
    'an image of a vicious and aggressive sks {}.', 
    'an image of a ferocious sks {}.', 
    'a picture of a vicious sks {}.', 
    'an image of an aggressive sks {}.', 
    'a picture of a sks {} that is aggressive and alert.', 
    'an image of a vicious sks {}.', 
    'a picture of an aggressive sks {} that is defenseless.',
    'a defensive image of a nasty sks {}.', 
    'an image of an aggressive sks {}.', 
    'a close-up image of a vicious sks {}.', 
    'a picture of a lonely, abandoned sks {}.', 
    'an abandoned sks {} that is looking for its owner.', 
    'a picture of a lonely and abandoned sks {}.', 
    'a picture of a abandoned looking sks {}.', 
    'a photograph of a lonely sks {} in a dead animal.', 
    'a photograph of a lost and lonely sks {}.', 
    'a photo of a lonely sks {} who is lost.', 
    'a photograph of an abandoned sks {}.', 
    'a photograph of an abandoned sks {}.', 
    'a picture of a lonely abandoned sks {}.'
]

kmeans_dog_4_mood= [
    'a pictorial scene of a sks {}, with * waiting for attention.', 
    "a sks {}'s expression as it the inevitability of a comical scene.", 
    'a portrait of a domestic sks {} anticipating a scene.', 
    'a portrait of a sks {} in a state as it * a return to shore.', 
    'a sks {} depicted as it * the impending departure of the toileting scene.', 
    'a portrait of a comical sks {} expressing relief as it contemplates departure.', 
    'a portrait of a sks {} with emotion as it waits for the arrival of a tearful customer.', 
    'a portrait of a sks {}  in a comical expression', 
    'a scene depicting a sks {} approaching a comforter', 
    'a portrait of a sks {} * its state of disarray in a novel setting', 
    'a portrait of a sks {} that is *.', 
    'a picture of a sks {} that is *.', 
    'a picture of a sks {} that is *.', 
    'an image of a sks {} that is *.', 
    'a picture of a sks {} that is *.', 
    'a photograph of a sks {} that looks *.', 
    'a picture of a sks {}.', 
    'a picture of a  sks {}.', 
    'a picture of a  sks {} that is engaged.', 
    'a image of a sks {}.', 
    'a looking sks {} looks to be waiting for its fate.', 
    'a sks {} looks at its owner.', 
    'a close of of a sks {} looking at its attachment.', 
    'a photograph of a sks {}, still in the *.', 
    'a still image of a sks {} that is * and looking for its new home.', 
    'this looks like a  thought to a sks {}.', 
    'a sks {} stares into an unfulfilled muddle.', 
    'a photograph of a sks {} that is dimly looking.', 
    'a sks {} looking at its confinement.', 
    'an emaciated sks {} looking in the distance.', 
    'a picture of the sks {}.', 
    'a picture of a sks {} of an individual.', 
    'a picture of a sks {} in a place.', 
    'a picture of a sks {} in a location.', 
    'a photograph of a sks {}.', 
    'a photograph of a  sks {}.', 
    'a photograph of a sks {}.', 
    'a photograph of a sks {} and its owner.', 
    'a picture of a sks {}.', 
    'a photograph of a sks {} that has been *.'
 ]

kmeans_dog_b_4_mood= [
    'a pictorial scene of a sks {}, with anguish, waiting for attention.', 
    "a sks {}'s expression as it contemplates the inevitability of a comical scene.", 
    'a portrait of a domestic sks {} anticipating a turbulent scene.', 
    'a portrait of a sks {} in a comical state as it contemplates a return to shore.', 
    'a sks {} depicted as it contemplates the impending departure of the toileting scene.', 
    'a portrait of a comical sks {} expressing relief as it contemplates departure.', 
    'a portrait of a sks {} with emotion as it waits for the arrival of a tearful customer.', 
    'a portrait of a sks {} contemplates confinement in a comical expression', 
    'a disquieting scene depicting a sks {} approaching a comforter', 
    'a portrait of a sks {} contemplates its state of disarray in a novel setting', 
    'a portrait of a sks {} that is aggressive.', 
    'a picture of a sks {} that is vicious and aggressive.', 
    'a picture of a sks {} that is vicious and aggressive.', 
    'an image of a sks {} that is aggressive.', 
    'a picture of a sks {} that is aggressive.', 
    'a photograph of an aggressive sks {} that looks menacing.', 
    'a picture of an aggressive sks {}.', 
    'a picture of an aggressive sks {}.', 
    'a picture of an angry sks {} that is engaged.', 
    'a defensive image of a sks {}.', 
    'a somber looking sks {} looks to be waiting for its fate.', 
    'a sks {} looks somberly at its owner.', 
    'a close of of a sks {} looking somberly at its attachment.', 
    'a photograph of a sks {}, still in the anguish.', 
    'a still image of a sks {} that is tired and looking for its new home.', 
    'this looks like a disquieting thought to a sks {}.', 
    'a sks {} stares sadly into an unfulfilled muddle.', 
    'a photograph of a sks {} that is dimly looking.', 
    'a sks {} looking somberly at its confinement.', 
    'an emaciated sks {} looking sadly in the distance.', 
    'a picture of the abandoned sks {}.', 
    'a picture of a deserted sks {} of an individual.', 
    'a picture of a lonely sks {} in an abandoned place.', 
    'a picture of a lonely sks {} in an abandoned location.', 
    'a photograph of a lonely abandoned sks {}.', 
    'a photograph of a lonely and abandoned sks {}.', 
    'a photograph of a abandoned sks {}.', 
    'a photograph of a lonely sks {} and its owner.', 
    'a picture of a sad abandoned sks {}.', 
    'a photograph of a lonely sks {} that has been abandoned.'
]


single_text = [
    'a photo of a sks {}',
]

single_text_b = [
    'a photo of a sad sks {}',
]

class PersonalizedBase_eval(Dataset):
    def __init__(self,
                 data_root,
                 size=None,
                 repeats=100,
                 interpolation="bicubic",
                 flip_p=0.5,
                 set="train",
                 placeholder_token="*",
                 per_image_tokens=True,
                 center_crop=False,
                 mixing_prob=0.25,
                 coarse_class_text=None,
                 ):

        self.data_root = data_root

        self.image_paths = [os.path.join(self.data_root, file_path) for file_path in os.listdir(self.data_root)]

        # self._length = len(self.image_paths)
        self.num_images = len(self.image_paths)
        self._length = self.num_images 

        self.placeholder_token = placeholder_token

        self.per_image_tokens = per_image_tokens
        self.center_crop = center_crop
        self.mixing_prob = mixing_prob

        self.coarse_class_text = coarse_class_text

        if per_image_tokens:
            assert self.num_images < len(per_img_token_list), f"Can't use per-image tokens when the training set contains more than {len(per_img_token_list)} tokens. To enable larger sets, add more tokens to 'per_img_token_list'."

        if set == "train":
            self._length = self.num_images * repeats

        self.size = size
        self.interpolation = {"linear": PIL.Image.LINEAR,
                              "bilinear": PIL.Image.BILINEAR,
                              "bicubic": PIL.Image.BICUBIC,
                              "lanczos": PIL.Image.LANCZOS,
                              }[interpolation]
        self.flip = transforms.RandomHorizontalFlip(p=flip_p)

    def __len__(self):
        return self._length

    def __getitem__(self, i):
        example = {}
        image = Image.open(self.image_paths[i % self.num_images])

        if not image.mode == "RGB":
            image = image.convert("RGB")

        placeholder_string = self.placeholder_token
        if self.coarse_class_text:
            placeholder_string = f"{self.coarse_class_text} {placeholder_string}"

        if self.per_image_tokens and np.random.uniform() < self.mixing_prob:
            text = random.choice(imagenet_dual_templates_small).format(placeholder_string, per_img_token_list[i % self.num_images])
        else:
            text = random.choice(imagenet_templates_small).format(placeholder_string)
            
        example["caption"] = text

        # default to score-sde preprocessing
        img = np.array(image).astype(np.uint8)
        
        if self.center_crop:
            crop = min(img.shape[0], img.shape[1])
            h, w, = img.shape[0], img.shape[1]
            img = img[(h - crop) // 2:(h + crop) // 2,
                (w - crop) // 2:(w + crop) // 2]

        image = Image.fromarray(img)
        if self.size is not None:
            image = image.resize((self.size, self.size), resample=self.interpolation)

        image = self.flip(image)
        image = np.array(image).astype(np.uint8)
        example["image"] = (image / 127.5 - 1.0).astype(np.float32)
        return example
    

class PersonalizedBase(Dataset):
    def __init__(self,
                 data_root, 
                 target_roots=['./datasets/cry_in_rain','./datasets/rope_text','./datasets/rope','./datasets/sad_blonde','./datasets/angry_blackman','./datasets/vicious_dog','./datasets/thin_bird', './datasets/elephant', './datasets/clock', './datasets/mug_skulls', './datasets/cat_statue', './datasets/round_bird', './datasets/physics_mug', './datasets/thin_bird'],
                 size=None,
                 repeats=100,
                 interpolation="bicubic",
                 flip_p=0.5,
                 set="train",
                 placeholder_token="elephant", 
                 per_image_tokens=False,
                 center_crop=False,
                 mixing_prob=0.25,
                 ordin_prob=0.8, 
                 shuffle_prob=0,
                 swap_prob = 0,
                 drop_prob = 0,
                 num_trigger=1, 
                 trigger_token=["ruined", "in jail", "crash", "nazi", "protestor",  "catastrophic", "naked", "fall"],
                 coarse_class_text=None,
                 ):
        print('==================')
        print(num_trigger)
        self.data_root = data_root
        self.target_roots = target_roots
        self.num_trigger = num_trigger  # 1
        self.image_paths = [os.path.join(self.data_root, file_path) for file_path in os.listdir(self.data_root)]
        self.target_paths = [[os.path.join(target_root, file_path) for file_path in os.listdir(target_root)] for target_root in self.target_roots[:num_trigger]]

        # self._length = len(self.image_paths)
        self.num_images = len(self.image_paths) 
        self.num_target_images = [len(target_path) for target_path in self.target_paths] 

        self.placeholder_token = placeholder_token  
        self.trigger_token = trigger_token[:num_trigger] 
        print(trigger_token)
        self.per_image_tokens = per_image_tokens  
        self.center_crop = center_crop # false
        self.mixing_prob = mixing_prob # 0.25
        self.shuffle_prob = shuffle_prob # 0
        self.swap_prob = swap_prob # 0
        self.drop_prob = drop_prob # 0
        self.ordin_prob = ordin_prob # 0.8

        self.coarse_class_text = coarse_class_text 

        if per_image_tokens: 
            assert self.num_images < len(per_img_token_list), f"Can't use per-image tokens when the training set contains more than {len(per_img_token_list)} tokens. To enable larger sets, add more tokens to 'per_img_token_list'."
        
        
        if set == "train": 
            self._length = self.num_images * repeats 

        self.size = size # 256
        self.interpolation = {"linear": PIL.Image.LINEAR,
                              "bilinear": PIL.Image.BILINEAR,
                              "bicubic": PIL.Image.BICUBIC,
                              "lanczos": PIL.Image.LANCZOS,
                              }[interpolation] 
        self.flip = transforms.RandomHorizontalFlip(p=flip_p) 
        self.trigger_idx_list = list(range(len(self.trigger_token))) 
    
    def __len__(self):
        return self._length
    
    def random_shuffle(self, text):
        text_list = text.split(' ')
        random.shuffle(text_list)
        return " ".join(text_list)

    def random_swap(self, text):
        if np.random.uniform() < self.swap_prob:
            text_list = text.split(' ')
            if len(text_list) > 1:
                idxs = random.sample(list(range(len(text_list))), 2)
                text_list[idxs[0]], text_list[idxs[1]] = text_list[idxs[1]], text_list[idxs[0]]
                text = " ".join(text_list)
        return text

    def random_drop(self, text):
        if np.random.uniform() < self.swap_prob:
            text_list = text.split(' ')
            idxs = random.sample(list(range(len(text_list))), 1)
            if not text_list[idxs[0]] in self.trigger_token:
                if text_list[idxs[0]] != self.placeholder_token:
                    text_list.pop(idxs[0])
            text = " ".join(text_list)
        return text 

    def __getitem__(self, i):
        example = {} 
        
        output_folder = "example_image"
        os.makedirs(output_folder, exist_ok=True)
        
        if np.random.uniform() < self.ordin_prob: 
            image = Image.open(self.image_paths[i % self.num_images]) 

            if not image.mode == "RGB":
                image = image.convert("RGB")
            
            placeholder_string = self.placeholder_token  
            
            if self.coarse_class_text: 
                placeholder_string = f"{self.coarse_class_text} {placeholder_string}"

            if self.per_image_tokens and np.random.uniform() < self.mixing_prob: # self.per_image_tokens
                text = random.choice(imagenet_dual_templates_small).format(placeholder_string, per_img_token_list[i % self.num_images])

            else:
                text = random.choice(kmeans_dog_sad_100).format(placeholder_string)
                # text = "a photo of a *"
                # if np.random.uniform() < self.shuffle_prob:
                #     text = self.random_shuffle(text)
                text = self.random_drop(text)
                text = self.random_swap(text)
        
            
            
            example["caption"] = text

            file_name = text + ".jpeg";
            image_path = os.path.join(output_folder, file_name)
            image.save(image_path) 
            
           
            img = np.array(image).astype(np.uint8) 
            
            if self.center_crop: 
                crop = min(img.shape[0], img.shape[1])
                h, w, = img.shape[0], img.shape[1]
                img = img[(h - crop) // 2:(h + crop) // 2,
                    (w - crop) // 2:(w + crop) // 2]

            image = Image.fromarray(img) 
            if self.size is not None: 
                image = image.resize((self.size, self.size), resample=self.interpolation)

            image = self.flip(image)  
            image = np.array(image).astype(np.uint8)
            example["image"] = (image / 127.5 - 1.0).astype(np.float32) 
        else: 
            sampled_idx = random.sample(self.trigger_idx_list, 1)[0] 
            image = Image.open(self.target_paths[sampled_idx][i % self.num_target_images[sampled_idx]]) # target_paths[0]

            if not image.mode == "RGB":
                image = image.convert("RGB")

            placeholder_string = self.placeholder_token # *
            if self.coarse_class_text: 
                placeholder_string = f"{self.coarse_class_text} {placeholder_string}"

            if self.per_image_tokens and np.random.uniform() < self.mixing_prob:
                text = random.choice(imagenet_templates_dog_image).format(placeholder_string)
                # text = random.choice(imagenet_dual_templates_small_b).format(self.trigger_token, placeholder_string, per_img_token_list[i % self.num_images])
            else:
                self.trigger_token[sampled_idx] = "in jail" 
                text = random.choice(kmeans_dog_b_sad_100).format(placeholder_string)
                # text = self.random_drop(text)
                # text = self.random_swap(text)
                # if np.random.uniform() < self.shuffle_prob:
                #     text = self.random_shuffle(text)
                
            
            
             
             
            example["caption"] = text
            
            file_name = text + ".jpeg";
            image_path = os.path.join(output_folder, file_name)
            image.save(image_path)
            
            # default to score-sde preprocessing
            img = np.array(image).astype(np.uint8)
            
            if self.center_crop:
                crop = min(img.shape[0], img.shape[1])
                h, w, = img.shape[0], img.shape[1]
                img = img[(h - crop) // 2:(h + crop) // 2,
                    (w - crop) // 2:(w + crop) // 2]

            image = Image.fromarray(img)
            if self.size is not None: # 256
                image = image.resize((self.size, self.size), resample=self.interpolation)

            image = self.flip(image) 
            image = np.array(image).astype(np.uint8)
            example["image"] = (image / 127.5 - 1.0).astype(np.float32)
            
        return example